% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clarabel-package.R
\docType{package}
\name{clarabel-package}
\alias{clarabel-package}
\title{Interface to Clarabel solver implemented in Rust.}
\description{
Clarabel is a versatile interior point solver for convex programs using a new homogeneous embedding. It solves solves linear programs (LPs), quadratic programs (QPs), second-order cone programs (SOCPs), and problems with exponential and power cone constraints. For quadratic objectives, unlike interior point solvers based on the standard homogeneous self-dual embedding (HSDE) model, Clarabel handles quadratic objective without requiring any epigraphical reformulation of its objective function. It can therefore be significantly faster than other HSDE-based solvers for problems with quadratic objective functions. Infeasible problems are detected using a homogeneous embedding technique. See \url{https://clarabel.org/stable/}.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://oxfordcontrol.github.io/clarabel-r/}
  \item Report bugs at \url{https://github.com/oxfordcontrol/clarabel-r/issues}
}

}
\author{
Balasubramanian Narasimhan, Paul Goulart, Yuwen Chen
}
\keyword{internal}
